package sorting;

import java.util.Random;

public class BubbleSortTest {

	
	public static void main(String argv[]) {
		
		/* TEST 1:  sort an array with one element*/
		System.out.println("TEST 1:  sort an array with one element");
		Integer[] a = new Integer[1];
		a[0] = 1;
		Integer[] b = a.clone();
		BubbleSort.bubbleSort(a);	
		if(java.util.Arrays.equals(a,b)) {
			System.out.println("Test successful");
		} else {
			System.out.println("Test failed");				
		}
		
		/* TEST 2-10:  sort an array with random elements*/
		for (int t=2; t <=10; t++) {
			Random rand = new Random();
			int max = 1000;
			int n = rand.nextInt(max);
			System.out.println("TEST " + t + ":  sort an array with " + n + " random elements");
			a = new Integer[n];
			for (int i=0; i < n; i++) {
				a[i] = rand.nextInt();
			}
	
			b = a.clone();
			BubbleSort.bubbleSort(a);	
			java.util.Arrays.sort(b);
			if(java.util.Arrays.equals(a,b)) {
				System.out.println("Test successful");
			} else {
				System.out.println("Test failed");				
			}	
			
			
		}
	}
}

