package sorting;

import java.util.LinkedList;
import java.util.List;

public class RadixSort {

	
	public static void radixSort(String[] a) {
		
		int n = a.length;
		int d = 0;
		for (String stringItem : a) {
			if (stringItem.length() > d) d = stringItem.length();
		}
		
		for (int j = d-1; j >= 0; j--) {
			List<String>[] groups = new LinkedList[27];
			int[] counter = new int[27];
			for (int i=0; i < 27; i++) {
				groups[i] = new LinkedList<String>();
				counter[i] = 0;
			}

			for (int i=0; i < n; i++) {
				int k = 0;  
				try {
					k = a[i].charAt(j);
					k = k - 'A';
				} catch (StringIndexOutOfBoundsException e) {}
				groups[k].add(a[i]);
				counter[k] += 1;
			}
			
			int s = 0;
			for (int i = 0; i < 27; i++) {
				for (int t=0; t < counter[i]; t++)
					a[s++] = groups[i].get(t);
				
			}
			
		}
	}
	
}
